﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using Syncfusion.UI.Xaml.Grid.Helpers;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Reflection;
using Syncfusion.Data;

namespace SfDataGridDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.grid.CellRenderers.Remove("CaptionSummary"); 
            this.grid.CellRenderers.Add("CaptionSummary", new CaptionSummaryRenderer());
        }
    }

    public class CaptionSummaryRenderer : GridCaptionSummaryCellRenderer
    {
        public override void OnUpdateEditBinding(DataColumnBase dataColumn, GridCaptionSummaryCell element, object dataContext)
        {
            base.OnUpdateEditBinding(dataColumn, element, dataContext);
            var groupRecord = element.DataContext as Group;
            if (groupRecord == null)
                return;
            var groupedColumn = this.GetGroupedColumn(groupRecord);
            if (groupedColumn == null)
                return;
            
            if (element.Content == "")
                element.Content = groupedColumn.HeaderText + ":" + groupRecord.Key;
        }
        private GridColumn GetGroupedColumn(Group group)
        {
            var groupDesc = this.DataGrid.View.GroupDescriptions[group.Level - 1] as ColumnGroupDescription;
            
            foreach (var column in this.DataGrid.Columns)
            {
                if (column.MappingName == groupDesc.PropertyName)
                {
                    return column;
                }
            }
            return null;
        }
    }
}
